unit main;

interface

uses
  RasDlg, //Ras dialogs
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    btnRasEntryDlg: TButton;
    btnRasPhonebookDlg: TButton;
    btnRasDialDlg: TButton;
    grpMonitor: TGroupBox;
    rbStatus: TRadioButton;
    rbSummary: TRadioButton;
    rbPreferences: TRadioButton;
    btnRasMonitorDlg: TButton;
    procedure btnRasEntryDlgClick(Sender: TObject);
    procedure btnRasPhonebookDlgClick(Sender: TObject);
    procedure btnRasDialDlgClick(Sender: TObject);
    procedure btnRasMonitorDlgClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure AddList(str:String);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.AddList(str: String);
begin
 ListBox1.Items.Add(str);
end;

procedure TForm1.btnRasEntryDlgClick(Sender: TObject);
var
 mySTRUCT:LPRasEntryDlg;
begin
 New(mySTRUCT);
 FillChar(mySTRUCT^,SizeOF(mySTRUCT^),0);
 with mySTRUCT^ do
  begin
   dwSize:=SizeOF(mySTRUCT^);
   hwndOwner:=Self.Handle;
   dwFlags:=RASEDFLAG_NewEntry;
   xDlg:=0;
   yDlg:=0;
  end;
 if RasEntryDlg(nil,PChar('testentry'),mySTRUCT) then
  AddList('EntryDlg OK')
 else
  AddList('EntryDlg failed');
 AddList('dwStatus = '+IntToStr(mySTRUCT^.dwError));
 Dispose(mySTRUCT);
end;

procedure TForm1.btnRasPhonebookDlgClick(Sender: TObject);
var
 mySTRUCT:LPRasPbDlg;
begin
 New(mySTRUCT);
 FillChar(mySTRUCT^,SizeOF(mySTRUCT^),0);
 with mySTRUCT^ do
  begin
   dwSize:=SizeOF(mySTRUCT^);
   hwndOwner:=Self.Handle;
   pCallback:=nil;
   xDlg:=0;
   yDlg:=0;
  end;
 RasPhonebookDlg(nil,nil,mySTRUCT);
 AddList('dwStatus = '+IntToStr(mySTRUCT^.dwError));
 Dispose(mySTRUCT);
end;

procedure TForm1.btnRasDialDlgClick(Sender: TObject);
var
 mySTRUCT:LPRasDialDlg;
begin
 New(mySTRUCT);
 FillChar(mySTRUCT^,SizeOF(mySTRUCT^),0);
 with mySTRUCT^ do
  begin
   dwSize:=SizeOF(mySTRUCT^);
      hwndOwner:=Self.Handle;
  end;
 if RasDialDlg(nil,PChar('testentry'),nil,mySTRUCT) then
  AddList('DialDlg OK')
 else
  AddList('DialDlg failed');
 AddList('dwStatus = '+IntToStr(mySTRUCT^.dwError));
 Dispose(mySTRUCT);
end;

procedure TForm1.btnRasMonitorDlgClick(Sender: TObject);
var
 mySTRUCT:LPRasMonitorDlg;
begin
 New(mySTRUCT);
 FillChar(mySTRUCT^,SizeOF(mySTRUCT^),0);
 with mySTRUCT^ do
  begin
   dwSize:=SizeOF(mySTRUCT^);
   hwndOwner:=Self.Handle;
   if rbStatus.Checked then
    dwStartPage:=RASMDPAGE_Status;
   if rbSummary.Checked then
    dwStartPage:=RASMDPAGE_Summary;
   if rbPreferences.Checked then
    dwStartPage:=RASMDPAGE_Preferences;
  end;
 RasMonitorDlg(nil,mySTRUCT);
 AddList('dwStatus = '+IntToStr(mySTRUCT^.dwError));
 Dispose(mySTRUCT);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 if InitRasDlg then
  AddList('RasDlg initialized')
 else
  begin
   AddList('RasDlg functions non-existing');
   btnRasEntryDlg.Enabled:=False;
   btnRasPhonebookDlg.Enabled:=False;
   btnRasDialDlg.Enabled:=False;
   btnRasMonitorDlg.Enabled:=False;
   grpMonitor.Enabled:=False;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 CloseRasDlg;
end;

end.
