{$A+} //RasEntryDlg requires alignment
unit rasdlg;
(* Copyright (c) 1995-1996, Microsoft Corporation, all rights reserved
**
** rasdlg.h
** Remote Access Common Dialog APIs
** Public header
**
** These APIs live in RASDLG.DLL.
**
** The APIs in this header are added in Windows NT SUR and are not available
** in prior Windows NT or Windows 95 releases.
**
**
**
**  Delphi information:
**  Translation by Arne Damvin <arne@damvin.com>
**
**  Distribute freely.
**
**  Note: All functions and structures defaults to Ansi. If you want to use
**        Unicode structs and funcs, use the names ending with 'W'
**        The 'W' funcs are _very_ untested ;-)
**
** Thanks to David Moretti <dmoretti@iper.net> for the Ras.h conversion
*)
interface
uses
 Windows,
 SysUtils;

//constants snatched from the Rasapi translation by D. Moretti
const
  UNLEN =                 256; // Maximum user name length
  RAS_MaxPhoneNumber =    128;
  RAS_MaxEntryName =      256; //Defaults to Ver4 sizes since this API only exists on NT 4.0 and up

//Beginning of rasdlg-api translation
type
// RasPhonebookDlg API callback.
 RASPBDLGFUNCA = procedure(dwCallbackID,dwEvent:Longint;pszText:PAnsiChar;pData:Pointer); stdcall;
 RASPBDLGFUNCW = procedure(dwCallbackID,dwEvent:Longint;pszText:PWideChar;pData:Pointer); stdcall;

const
  RASPBDEVENT_AddEntry =    1;
  RASPBDEVENT_EditEntry =   2;
  RASPBDEVENT_RemoveEntry = 3;
  RASPBDEVENT_DialEntry =   4;
  RASPBDEVENT_EditGlobals = 5;
  RASPBDEVENT_NoUser =      6;
  RASPBDEVENT_NoUserEdit =  7;

// Defines the information passed in the 4th argument of RASPBDLGFUNC on
// "NoUser" and "NoUserEdit" events.  Usage shown is for "NoUser".  For
// "NoUserEdit", the timeout is ignored and the three strings are INs.

type
 LPRasNoUserA = ^TRasNoUserA;
 TRasNoUserA = record
  dwSize,
  dwFlags,
  dwTimeoutMS:Longint;
  szUserName:Array[0..UNLEN] of AnsiChar;
  szPassword:Array[0..UNLEN] of AnsiChar;
  szDomain:Array[0..UNLEN] of AnsiChar;
 end;

 LPRasNoUserW = ^TRasNoUserW;
 TRasNoUserW = record
  dwSize,
  dwFlags,
  dwTimeoutMS:Longint;
  szUserName:Array[0..UNLEN] of WideChar;
  szPassword:Array[0..UNLEN] of WideChar;
  szDomain:Array[0..UNLEN] of WideChar;
 end;

 LPRasNoUser = LPRasNoUserA;
 TRasNoUser = TRasNoUserA;

const
// RasPhonebookDlg API parameters.
 RASPBDFLAG_PositionDlg =      $00000001;
 RASPBDFLAG_ForceCloseOnDial = $00000002;
 RASPBDFLAG_NoUser =           $00000010;
 RASPBDFLAG_UpdateDefaults =   $80000000;

type
 LPRasPbDlgA = ^TagRasPbDlgA;
 TagRasPbDlgA = record
  dwSize,
  hwndOwner,
  dwFlags,
  xDlg,
  yDlg,
  dwCallbackID:Longint;
  pCallback:RASPBDLGFUNCA;
  dwError,
  reserved,
  reserved2:Longint;
 end;

 LPRasPbDlgW = ^TagRasPbDlgW;
 TagRasPbDlgW = record
  dwSize,
  hwndOwner,
  dwFlags,
  xDlg,
  yDlg,
  dwCallbackID:Longint;
  pCallback:RASPBDLGFUNCW;
  dwError,
  reserved,
  reserved2:Longint;
 end;

 LPRasPbDlg = LPRasPbDlgA;
 TagRasPbDlg = TagRasPbDlgA;

// RasEntryDlg API parameters.
const
 RASEDFLAG_PositionDlg = $00000001;
 RASEDFLAG_NewEntry =    $00000002;
 RASEDFLAG_CloneEntry =  $00000004;
 RASEDFLAG_NoRename =    $00000008;
 RASEDFLAG_ShellOwned =  $40000000;

type
 LPRasEntryDlgA = ^TagRasEntryDlgA;
 TagRasEntryDlgA = record
  dwSize,
  hwndOwner,
  dwFlags,
  xDlg,
  yDlg:Longint;
  szEntry:Array[0..RAS_MaxEntryName] of AnsiChar;
  dwError,
  reserved,
  reserved2:Longint;
 end;

 LPRasEntryDlgW = ^TagRasEntryDlgW;
 TagRasEntryDlgW = record
  dwSize,
  hwndOwner,
  dwFlags,
  xDlg,
  yDlg:Longint;
  szEntry:Array[0..RAS_MaxEntryName] of WideChar;
  dwError,
  reserved,
  reserved2:Longint;
 end;

 LPRasEntryDlg = LPRasEntryDlgA;
 TagRasEntryDlg = TagRasEntryDlgA;

// RasDialDlg API parameters.
const
 RASDDFLAG_PositionDlg = $00000001;
 RASDDFLAG_LinkFailure = $80000000;

type
 LPRasDialDlg = ^TagRasDialDlg;
 TagRasDialDlg = record
  dwSize,
  hwndOwner,
  dwFlags,
  xDlg,
  yDlg,
  dwSubEntry,
  dwError,
  reserved,
  reserved2:Longint;
 end;

// RasMonitorDlg API parameters.
const
 RASMDPAGE_Status =      0;
 RASMDPAGE_Summary =     1;
 RASMDPAGE_Preferences = 2;

 RASMDFLAG_PositionDlg =    $00000001;
 RASMDFLAG_UpdateDefaults = $80000000;

type
 LPRasMonitorDlg = ^TagRasMonitorDlg;
 TagRasMonitorDlg = record
  dwSize,
  hwndOwner,
  dwFlags,
  dwStartPage,
  xDlg,
  yDlg,
  dwError,
  reserved,
  reserved2:Longint;
 end;

// RAS common dialog API prototypes.
type
 TRasPhonebookDlgA = function(lpszPhonebook:PAnsiChar;lpszEntry:PAnsiChar;lpInfo:LPRasPbDlgA):LongBool; stdcall;
 TRasPhonebookDlgW = function(lpszPhonebook:PWideChar;lpszEntry:PWideChar;lpInfo:LPRasPbDlgW):LongBool; stdcall;
 TRasPhonebookDlg = TRasPhonebookDlgA;
 TRasEntryDlgA = function(lpszPhonebook:PAnsiChar;lpszEntry:PAnsiChar;lpInfo:LPRasEntryDlgA):LongBool; stdcall;
 TRasEntryDlgW = function(lpszPhonebook:PWideChar;lpszEntry:PWideChar;lpInfo:LPRasEntryDlgW):LongBool; stdcall;
 TRasEntryDlg = TRasEntryDlgA;
 TRasDialDlgA = function(lpszPhonebook:PAnsiChar;lpszEntry:PAnsiChar;lpszPhoneNumber:PAnsiChar;lpInfo:LPRasDialDlg):LongBool; stdcall;
 TRasDialDlgW = function(lpszPhonebook:PWideChar;lpszEntry:PWideChar;lpszPhoneNumber:PWideChar;lpInfo:LPRasDialDlg):LongBool; stdcall;
 TRasDialDlg = TRasDialDlgA;
 TRasMonitorDlgA = function(lpszDeviceName:PAnsiChar;lpInfo:LPRasMonitorDlg):LongBool; stdcall;
 TRasMonitorDlgW = function(lpszDeviceName:PWideChar;lpInfo:LPRasMonitorDlg):LongBool; stdcall;
 TRasMonitorDlg = TRasMonitorDlgA;

//Library initialization/finalization
function InitRasDlg: Boolean;
function CloseRasDlg: Boolean;

//DLL dynamic link variables (names)
var
 RasPhonebookDlgA: TRasPhonebookDlgA;
 RasPhonebookDlgW: TRasPhonebookDlgW;
 RasPhonebookDlg: TRasPhonebookDlg;
 RasEntryDlgA: TRasEntryDlgA;
 RasEntryDlgW: TRasEntryDlgW;
 RasEntryDlg: TRasEntryDlg;
 RasDialDlgA: TRasDialDlgA;
 RasDialDlgW: TRasDialDlgW;
 RasDialDlg: TRasDialDlg;
 RasMonitorDlgA: TRasMonitorDlgA;
 RasMonitorDlgW: TRasMonitorDlgW;
 RasMonitorDlg: TRasMonitorDlg;

//DLL-check_if_exists_variables ;-)
var
 RasDlgFunc_init: Boolean = False;
 lib: HModule;
 hLib: THandle;

implementation

function RasDlgFunc(const func: String): Pointer;
begin
 if not RasDlgFunc_init then
  begin
   lib:=LoadLibrary('rasdlg.dll');
   if lib<>0 then
    begin
     Result:=GetProcAddress(lib,PChar(func));
     if Result<>nil then
      begin
       RasDlgFunc_init:=True;
       Exit;
      end
     else
      raise Exception.Create('Couldn''t find function '+func+'!');
    end
   else
    raise Exception.Create('Error opening rasdlg.dll');
  end
 else
  begin
   Result:=GetProcAddress(lib,PChar(func));
   if Result=nil then
    raise Exception.Create('Couldn''t find function '+func+'!');
  end;
end;

function InitRasDlg:Boolean;
begin
 hLib:=LoadLibrary('rasdlg.dll');
 if (hLib=0) then
  begin
   Result:=False;
   Exit;
  end;
 Result:=True;
 try
  RasPhoneBookDlgA:=TRasPhonebookDlgA(GetProcAddress(hLib,'RasPhonebookDlgA'));
 except
 end;
 try
  RasPhoneBookDlgW:=TRasPhonebookDlgW(GetProcAddress(hLib,'RasPhonebookDlgW'));
 except
 end;
 try
  RasPhoneBookDlg:=TRasPhonebookDlg(GetProcAddress(hLib,'RasPhonebookDlgA'));
 except
 end;
 try
  RasEntryDlgA:=TRasEntryDlgA(GetProcAddress(hLib,'RasEntryDlgA'));
 except
 end;
 try
  RasEntryDlgW:=TRasEntryDlgW(GetProcAddress(hLib,'RasEntryDlgW'));
 except
 end;
 try
  RasEntryDlg:=TRasEntryDlg(GetProcAddress(hLib,'RasEntryDlgA'));
 except
 end;
 try
  RasDialDlgA:=TRasDialDlgA(GetProcAddress(hLib,'RasDialDlgA'));
 except
 end;
 try
  RasDialDlgW:=TRasDialDlgW(GetProcAddress(hLib,'RasDialDlgW'));
 except
 end;
 try
  RasDialDlg:=TRasDialDlg(GetProcAddress(hLib,'RasDialDlgA'));
 except
 end;
 try
  RasMonitorDlgA:=TRasMonitorDlgA(GetProcAddress(hLib,'RasMonitorDlgA'));
 except
 end;
 try
  RasMonitorDlgW:=TRasMonitorDlgW(GetProcAddress(hLib,'RasMonitorDlgW'));
 except
 end;
 try
  RasMonitorDlg:=TRasMonitorDlg(GetProcAddress(hLib,'RasMonitorDlgA'));
 except
 end;
end;

function CloseRasDlg: Boolean;
begin
 if (hlib<>0) then
  FreeLibrary(hLib);
 Result:=True;
end;

initialization
finalization
 if RasDlgFunc_init then
  FreeLibrary(lib);
end.
